//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DimGray
#property indicator_color3  PaleVioletRed
#property indicator_color4  LimeGreen
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_color7  Red
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style7  STYLE_DOT

//
//
//
//
//

extern int    FastEMA      = 12;
extern int    SlowEMA      = 26;
extern int    SignalEMA    =  9;
extern int    Price        = PRICE_CLOSE;
extern int    MinMaxPeriod =  50;
extern double LevelUp      =  90;
extern double LevelDown    =  10;

double macd[];
double macdDa[];
double macdDb[];
double signal[];
double colors[];
double levelUp[];
double levelMi[];
double levelDn[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,levelUp);
   SetIndexBuffer(1,levelMi);
   SetIndexBuffer(2,levelDn);
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,macdDa);
   SetIndexBuffer(5,macdDb);
   SetIndexBuffer(6,signal);
   SetIndexBuffer(7,colors);
      IndicatorShortName("MACD ("+FastEMA+","+SlowEMA+","+SignalEMA+")");
   return(0);
}
int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double emas[][2];
int start()
{
   double alphaSign = 2.0/(1.0+SignalEMA);
   double alphaFast = 2.0/(1.0+FastEMA);
   double alphaSlow = 2.0/(1.0+SlowEMA);
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   //
   //
   //
   //
   //
   
   if (colors[limit]==-1) CleanPoint(limit,macdDa,macdDb);
   for(i = limit, r=Bars-i-1; i >= 0 ; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (i>Bars-2)
      {
         emas[r][0] = price;
         emas[r][1] = price;
         macd[i]    = 0;
         signal[i]  = 0;
         continue;
      }

      emas[r][0] = emas[r-1][0]+alphaFast*(price-emas[r-1][0]);
      emas[r][1] = emas[r-1][1]+alphaSlow*(price-emas[r-1][1]);
      macd[i]    = emas[r][0]-emas[r][1];
      macdDa[i]  = EMPTY_VALUE;
      macdDb[i]  = EMPTY_VALUE;
      signal[i]  = signal[i+1]+alphaSign*(macd[i]-signal[i+1]);
      colors[i]  = colors[i+1];
         if (macd[i]>macd[i+1]) colors[i] =  1;
         if (macd[i]<macd[i+1]) colors[i] = -1;
         if (colors[i]==-1) PlotPoint(i,macdDa,macdDb,macd);
      
      //
      //
      //
      //
      //
      
      double valMin = macd[ArrayMinimum(macd,MinMaxPeriod,i)];
      double valMax = macd[ArrayMaximum(macd,MinMaxPeriod,i)];
      double range  = valMax-valMin;
               levelUp[i] = valMin+range*LevelUp/100.0;
               levelMi[i] = valMin+range*0.5;
               levelDn[i] = valMin+range*LevelDown/100.0;
   }         
   return(0);
}


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}